unit DLLTools;

interface

uses SysUtils, Classes, windows;

function GetParameter(S:String;D:Char;I,L:Integer):String;
function GetParameterCount(S:String;D:Char):Integer;
function Limit(Min,C,Max: Integer):integer;
function ErrorToString(Error: Integer): String;


implementation

function GetParameter(S:String;D:Char;I,L:Integer):String;
var T:TStringList;
    C:Integer;
begin
    T := TStringList.Create;
    C := ExtractStrings([D],[D],PChar(S),T);
    if (I < 0) then I := C - I + 1;
    if (I = 0) then I := 1;
    if ((I > C) or (I+L-1 > C)) then begin Result := ''; Exit; end;
    C := I + L - 1;
    while (I <= C) do begin
        Result := Result + D + T[I-1];
        Inc(I);
    end;
    Result := Copy(Result,2,Length(Result)-1);
end;

function GetParameterCount(S:String;D:Char):Integer;
var T:TStringList;
begin            
    T := TStringList.Create;
    Result := ExtractStrings([D],[D],PChar(S),T);
end;

function Limit(Min,C,Max: Integer):integer;
begin
    if (C < Min) then Result := Min;
    if (C > Max) then Result := Max;
end;

function ErrorToString(Error: Integer): String;
var ErrMsg:Pchar;
begin
    ErrMsg:=GetMemory(200);
    FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,nil,Error,0,ErrMsg,200,nil);
    Result := String(ErrMsg);
    Result := copy(Result,1,length(Result)-2);
    FreeMemory(ErrMsg);
end;

end.

